"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var hasAlias = function (aliases) { return function (imported) {
    return aliases.some(function (alias) {
        return imported.moduleName === alias ||
            imported.moduleName.indexOf(alias + "/") === 0;
    });
}; };
exports.default = (function (styleApi, _file, _a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.alias, aliases = _c === void 0 ? [] : _c, _d = _b.overrideBuiltinModules, overrideBuiltinModules = _d === void 0 ? true : _d;
    var alias = styleApi.alias, and = styleApi.and, dotSegmentCount = styleApi.dotSegmentCount, hasNoMember = styleApi.hasNoMember, isNodeModule = styleApi.isNodeModule, isAbsoluteModule = styleApi.isAbsoluteModule, isRelativeModule = styleApi.isRelativeModule, moduleName = styleApi.moduleName, naturally = styleApi.naturally, not = styleApi.not, unicode = styleApi.unicode;
    var isAliasModule = hasAlias(aliases || []);
    return [
        // import "foo"
        { match: and(hasNoMember, isAbsoluteModule, not(isAliasModule)) },
        { separator: true },
        // import "{relativeAlias}/foo"
        { match: and(hasNoMember, isAbsoluteModule, isAliasModule) },
        { separator: true },
        // import "./foo"
        { match: and(hasNoMember, isRelativeModule) },
        { separator: true },
        // import … from "fs";
        {
            match: overrideBuiltinModules
                ? and(isNodeModule, not(isAliasModule))
                : isNodeModule,
            sort: moduleName(naturally),
            sortNamedMembers: alias(unicode),
        },
        { separator: true },
        // import … from "foo";
        {
            match: and(isAbsoluteModule, not(isAliasModule)),
            sort: moduleName(naturally),
            sortNamedMembers: alias(unicode),
        },
        { separator: true },
        // import … from "{relativeAlias}/foo";
        {
            match: and(isAbsoluteModule, isAliasModule),
            sort: moduleName(naturally),
            sortNamedMembers: alias(unicode),
        },
        { separator: true },
        // import … from "./foo";
        // import … from "../foo";
        {
            match: isRelativeModule,
            sort: [dotSegmentCount, moduleName(naturally)],
            sortNamedMembers: alias(unicode),
        },
        { separator: true },
    ];
});
